diff --git a/gfx/harfbuzz/src/sample.py b/gfx/harfbuzz/src/sample.py
index 654c8e8d5c..eef72de5d1 100755
--- a/gfx/harfbuzz/src/sample.py
+++ b/gfx/harfbuzz/src/sample.py
@@ -1,65 +1,66 @@
-#!/usr/bin/env python3
-
-import sys
-import array
-import gi
-gi.require_version('HarfBuzz', '0.0')
-from gi.repository import HarfBuzz as hb
-from gi.repository import GLib
-
-fontdata = open (sys.argv[1], 'rb').read ()
-text = sys.argv[2]
-# Need to create GLib.Bytes explicitly until this bug is fixed:
-# https://bugzilla.gnome.org/show_bug.cgi?id=729541
-blob = hb.glib_blob_create (GLib.Bytes.new (fontdata))
-face = hb.face_create (blob, 0)
-del blob
-font = hb.font_create (face)
-upem = hb.face_get_upem (face)
-del face
-hb.font_set_scale (font, upem, upem)
-#hb.ft_font_set_funcs (font)
-hb.ot_font_set_funcs (font)
-
-buf = hb.buffer_create ()
-class Debugger (object):
-	def message (self, buf, font, msg, data, _x_what_is_this):
-		print (msg)
-		return True
-debugger = Debugger ()
-hb.buffer_set_message_func (buf, debugger.message, 1, 0)
-
-##
-## Add text to buffer
-##
-#
-# See https://github.com/harfbuzz/harfbuzz/pull/271
-#
-# If you do not care about cluster values reflecting Python
-# string indices, then this is quickest way to add text to
-# buffer:
-# hb.buffer_add_utf8 (buf, text.encode('utf-8'), 0, -1)
-# Otherwise, then following handles both narrow and wide
-# Python builds (the first item in the array is BOM, so we skip it):
-if sys.maxunicode == 0x10FFFF:
-	hb.buffer_add_utf32 (buf, array.array ('I', text.encode ('utf-32'))[1:], 0, -1)
-else:
-	hb.buffer_add_utf16 (buf, array.array ('H', text.encode ('utf-16'))[1:], 0, -1)
-
-
-hb.buffer_guess_segment_properties (buf)
-
-hb.shape (font, buf, [])
-del font
-
-infos = hb.buffer_get_glyph_infos (buf)
-positions = hb.buffer_get_glyph_positions (buf)
-
-for info, pos in zip (infos, positions):
-	gid = info.codepoint
-	cluster = info.cluster
-	x_advance = pos.x_advance
-	x_offset = pos.x_offset
-	y_offset = pos.y_offset
-
-	print ("gid%d=%d@%d,%d+%d" % (gid, cluster, x_advance, x_offset, y_offset))
+#!/usr/bin/env python3
+
+from __future__ import print_function
+import sys
+import array
+import gi
+gi.require_version('HarfBuzz', '0.0')
+from gi.repository import HarfBuzz as hb
+from gi.repository import GLib
+
+fontdata = open (sys.argv[1], 'rb').read ()
+text = sys.argv[2]
+# Need to create GLib.Bytes explicitly until this bug is fixed:
+# https://bugzilla.gnome.org/show_bug.cgi?id=729541
+blob = hb.glib_blob_create (GLib.Bytes.new (fontdata))
+face = hb.face_create (blob, 0)
+del blob
+font = hb.font_create (face)
+upem = hb.face_get_upem (face)
+del face
+hb.font_set_scale (font, upem, upem)
+#hb.ft_font_set_funcs (font)
+hb.ot_font_set_funcs (font)
+
+buf = hb.buffer_create ()
+class Debugger (object):
+	def message (self, buf, font, msg, data, _x_what_is_this):
+		print (msg)
+		return True
+debugger = Debugger ()
+hb.buffer_set_message_func (buf, debugger.message, 1, 0)
+
+##
+## Add text to buffer
+##
+#
+# See https://github.com/harfbuzz/harfbuzz/pull/271
+#
+# If you do not care about cluster values reflecting Python
+# string indices, then this is quickest way to add text to
+# buffer:
+# hb.buffer_add_utf8 (buf, text.encode('utf-8'), 0, -1)
+# Otherwise, then following handles both narrow and wide
+# Python builds (the first item in the array is BOM, so we skip it):
+if sys.maxunicode == 0x10FFFF:
+	hb.buffer_add_utf32 (buf, array.array ('I', text.encode ('utf-32'))[1:], 0, -1)
+else:
+	hb.buffer_add_utf16 (buf, array.array ('H', text.encode ('utf-16'))[1:], 0, -1)
+
+
+hb.buffer_guess_segment_properties (buf)
+
+hb.shape (font, buf, [])
+del font
+
+infos = hb.buffer_get_glyph_infos (buf)
+positions = hb.buffer_get_glyph_positions (buf)
+
+for info, pos in zip (infos, positions):
+	gid = info.codepoint
+	cluster = info.cluster
+	x_advance = pos.x_advance
+	x_offset = pos.x_offset
+	y_offset = pos.y_offset
+
+	print(("gid%d=%d@%d,%d+%d" % (gid, cluster, x_advance, x_offset, y_offset)))
diff --git a/gfx/skia/generate_mozbuild.py b/gfx/skia/generate_mozbuild.py
index 33594bd32c..ed770d733d 100755
--- a/gfx/skia/generate_mozbuild.py
+++ b/gfx/skia/generate_mozbuild.py
@@ -1,5 +1,6 @@
 #!/usr/bin/env python
 
+from __future__ import print_function
 import os
 
 import locale
@@ -166,7 +167,7 @@ def generate_platform_sources():
 
   for plat in platforms:
     if os.system("cd skia && GYP_GENERATORS=dump_mozbuild ./gyp_skia -D OS=%s -D host_os=linux gyp/skia_lib.gyp" % plat) != 0:
-      print 'Failed to generate sources for ' + plat
+      print('Failed to generate sources for ' + plat)
       continue
 
 
@@ -174,7 +175,7 @@ def generate_platform_sources():
     sources[plat] = set(v.replace('../', 'skia/') for v in json.load(f));
     f.close()
 
-  return dict(sources.items() + generate_opt_sources().items())
+  return dict(list(sources.items()) + list(generate_opt_sources().items()))
 
 
 def generate_separated_sources(platform_sources):
@@ -308,11 +309,11 @@ def generate_separated_sources(platform_sources):
       separated[key].add(value)
 
   if os.system("cd skia && GYP_GENERATORS=dump_mozbuild ./gyp_skia -D OS=linux -D host_os=linux -R pdf gyp/pdf.gyp") != 0:
-    print 'Failed to generate sources for Skia PDF'
+    print('Failed to generate sources for Skia PDF')
   else:
     f = open('skia/sources.json');
     separated['pdf'].add('skia/src/core/SkMD5.cpp');
-    separated['pdf'].update(filter(lambda x: 'pdf' in x, set(v.replace('../', 'skia/') for v in json.load(f))));
+    separated['pdf'].update([x for x in set(v.replace('../', 'skia/') for v in json.load(f)) if 'pdf' in x]);
     f.close()
 
   return separated
@@ -479,7 +480,7 @@ def write_mozbuild(sources):
 
   f.close()
 
-  print 'Wrote ' + filename
+  print('Wrote ' + filename)
 
 def main():
   platform_sources = generate_platform_sources()
diff --git a/gfx/thebes/genTables.py b/gfx/thebes/genTables.py
index 0e902c52aa..28374bd200 100644
--- a/gfx/thebes/genTables.py
+++ b/gfx/thebes/genTables.py
@@ -8,10 +8,10 @@ def table_generator(f):
 
 def generate(output):
     output.write("const uint8_t gfxUtils::sPremultiplyTable[256*256] = {\n");
-    output.write(table_generator(lambda i: ((i / 256) * (i % 256) + 254) / 255) + "\n")
+    output.write(table_generator(lambda i: int((i // 256 * (i % 256) + 254) / 255)) + "\n")
     output.write("};\n");
     output.write("const uint8_t gfxUtils::sUnpremultiplyTable[256*256] = {\n");
-    output.write(table_generator(lambda i: (i % 256) * 255 / ((i / 256) if (i / 256) > 0 else 255) % 256) + "\n")
+    output.write(table_generator(lambda i: int((i % 256) * 255 / (i // 256 if i // 256 > 0 else 255) % 256)) + "\n")
     output.write("};\n");
 
 if __name__ == '__main__':
diff --git a/intl/icu/source/python/icutools/databuilder/utils.py b/intl/icu/source/python/icutools/databuilder/utils.py
index 3d53d18fae..5bd16393d0 100644
--- a/intl/icu/source/python/icutools/databuilder/utils.py
+++ b/intl/icu/source/python/icutools/databuilder/utils.py
@@ -77,12 +77,12 @@ def repeated_execution_request_looper(request):
     # dictionary of lists to list of dictionaries:
     ld = [
         dict(zip(request.repeat_with, t))
-        for t in zip(*request.repeat_with.values())
+        for t in zip(*list(request.repeat_with.values()))
     ]
     if not ld:
         # No special options given in repeat_with
         ld = [{} for _ in range(len(request.input_files))]
-    return zip(ld, request.specific_dep_files, request.input_files, request.output_files)
+    return list(zip(ld, request.specific_dep_files, request.input_files, request.output_files))
 
 
 def format_single_request_command(request, cmd_template, common_vars):
diff --git a/intl/uconv/tools/gen-big5-data.py b/intl/uconv/tools/gen-big5-data.py
index 1d0f59bb43..4bce14a368 100644
--- a/intl/uconv/tools/gen-big5-data.py
+++ b/intl/uconv/tools/gen-big5-data.py
@@ -91,7 +91,7 @@ static const char16_t kBig5LowBitsTable[] = {
 ''')
 
 for (low, high) in ranges:
-  for i in xrange(low, high):
+  for i in range(low, high):
     classFile.write('  0x%04X,\n' % (index[i] & 0xFFFF))
 
 classFile.write('''};
@@ -104,15 +104,15 @@ static const uint32_t kBig5AstralnessTable[] = {
 
 bits = []
 for (low, high) in astralRanges:
-  for i in xrange(low, high):
+  for i in range(low, high):
     bits.append(1 if index[i] > 0xFFFF else 0)
 # pad length to multiple of 32
-for i in xrange(32 - (len(bits) % 32)):
+for i in range(32 - (len(bits) % 32)):
   bits.append(0)
 i = 0
 while i < len(bits):
   accu = 0
-  for j in xrange(32):
+  for j in range(32):
     accu |= bits[i + j] << j
   classFile.write('  0x%08X,\n' % accu)
   i += 32
@@ -190,7 +190,7 @@ preferLast = [
 
 for codePoint in preferLast:
   # Python lists don't have .rindex() :-(
-  for i in xrange(len(index) - 1, -1, -1):
+  for i in range(len(index) - 1, -1, -1):
     candidate = index[i]
     if candidate == codePoint:
        classFile.write('''      case 0x%04X:
diff --git a/ipc/chromium/src/third_party/libevent/event_rpcgen.py b/ipc/chromium/src/third_party/libevent/event_rpcgen.py
index dead34c21c..06ef1d8f3f 100755
--- a/ipc/chromium/src/third_party/libevent/event_rpcgen.py
+++ b/ipc/chromium/src/third_party/libevent/event_rpcgen.py
@@ -14,6 +14,7 @@
 #    progress outputs that space stderr at the moment)
 # 3) emit other languages
 
+from __future__ import print_function
 import sys
 import re
 
@@ -33,7 +34,7 @@ headerdirect = []
 cppdirect = []
 
 def TranslateList(mylist, mydict):
-    return map(lambda x: x % mydict, mylist)
+    return [x % mydict for x in mylist]
 
 # Exception class for parse errors
 class RpcGenError(Exception):
@@ -48,17 +49,17 @@ class Struct:
         self._name = name
         self._entries = []
         self._tags = {}
-        print >>sys.stderr, '  Created struct: %s' % name
+        print('  Created struct: %s' % name, file=sys.stderr)
 
     def AddEntry(self, entry):
-        if self._tags.has_key(entry.Tag()):
+        if entry.Tag() in self._tags:
             raise RpcGenError(
                 'Entry "%s" duplicates tag number %d from "%s" '
                 'around line %d' % (entry.Name(), entry.Tag(),
                                     self._tags[entry.Tag()], line_count))
         self._entries.append(entry)
         self._tags[entry.Tag()] = entry.Name()
-        print >>sys.stderr, '    Added entry: %s' % entry.Name()
+        print('    Added entry: %s' % entry.Name(), file=sys.stderr)
 
     def Name(self):
         return self._name
@@ -72,7 +73,7 @@ class Struct:
     def PrintIndented(self, file, ident, code):
         """Takes an array, add indentation to each entry and prints it."""
         for entry in code:
-            print >>file, '%s%s' % (ident, entry)
+            print('%s%s' % (ident, entry), file=file)
 
 class StructCCode(Struct):
     """ Knows how to generate C code for a struct """
@@ -82,20 +83,20 @@ class StructCCode(Struct):
 
     def PrintTags(self, file):
         """Prints the tag definitions for a structure."""
-        print >>file, '/* Tag definition for %s */' % self._name
-        print >>file, 'enum %s_ {' % self._name.lower()
+        print('/* Tag definition for %s */' % self._name, file=file)
+        print('enum %s_ {' % self._name.lower(), file=file)
         for entry in self._entries:
-            print >>file, '  %s=%d,' % (self.EntryTagName(entry),
-                                        entry.Tag())
-        print >>file, '  %s_MAX_TAGS' % (self._name.upper())
-        print >>file, '};\n'
+            print('  %s=%d,' % (self.EntryTagName(entry),
+                                        entry.Tag()), file=file)
+        print('  %s_MAX_TAGS' % (self._name.upper()), file=file)
+        print('};\n', file=file)
 
     def PrintForwardDeclaration(self, file):
-        print >>file, 'struct %s;' % self._name
+        print('struct %s;' % self._name, file=file)
 
     def PrintDeclaration(self, file):
-        print >>file, '/* Structure declaration for %s */' % self._name
-        print >>file, 'struct %s_access_ {' % self._name
+        print('/* Structure declaration for %s */' % self._name, file=file)
+        print('struct %s_access_ {' % self._name, file=file)
         for entry in self._entries:
             dcl = entry.AssignDeclaration('(*%s_assign)' % entry.Name())
             dcl.extend(
@@ -104,20 +105,19 @@ class StructCCode(Struct):
                 dcl.extend(
                     entry.AddDeclaration('(*%s_add)' % entry.Name()))
             self.PrintIndented(file, '  ', dcl)
-        print >>file, '};\n'
+        print('};\n', file=file)
 
-        print >>file, 'struct %s {' % self._name
-        print >>file, '  struct %s_access_ *base;\n' % self._name
+        print('struct %s {' % self._name, file=file)
+        print('  struct %s_access_ *base;\n' % self._name, file=file)
         for entry in self._entries:
             dcl = entry.Declaration()
             self.PrintIndented(file, '  ', dcl)
-        print >>file, ''
+        print('', file=file)
         for entry in self._entries:
-            print >>file, '  ev_uint8_t %s_set;' % entry.Name()
-        print >>file, '};\n'
+            print('  ev_uint8_t %s_set;' % entry.Name(), file=file)
+        print('};\n', file=file)
 
-        print >>file, \
-"""struct %(name)s *%(name)s_new(void);
+        print("""struct %(name)s *%(name)s_new(void);
 struct %(name)s *%(name)s_new_with_arg(void *);
 void %(name)s_free(struct %(name)s *);
 void %(name)s_clear(struct %(name)s *);
@@ -127,7 +127,7 @@ int %(name)s_complete(struct %(name)s *);
 void evtag_marshal_%(name)s(struct evbuffer *, ev_uint32_t,
     const struct %(name)s *);
 int evtag_unmarshal_%(name)s(struct evbuffer *, ev_uint32_t,
-    struct %(name)s *);""" % { 'name' : self._name }
+    struct %(name)s *);""" % { 'name' : self._name }, file=file)
 
 
         # Write a setting function of every variable
@@ -140,22 +140,21 @@ int evtag_unmarshal_%(name)s(struct evbuffer *, ev_uint32_t,
                 self.PrintIndented(file, '', entry.AddDeclaration(
                     entry.AddFuncName()))
 
-        print >>file, '/* --- %s done --- */\n' % self._name
+        print('/* --- %s done --- */\n' % self._name, file=file)
 
     def PrintCode(self, file):
-        print >>file, ('/*\n'
+        print(('/*\n'
                        ' * Implementation of %s\n'
-                       ' */\n') % self._name
+                       ' */\n') % self._name, file=file)
 
-        print >>file, \
-              'static struct %(name)s_access_ __%(name)s_base = {' % \
-              { 'name' : self._name }
+        print('static struct %(name)s_access_ __%(name)s_base = {' % \
+              { 'name' : self._name }, file=file)
         for entry in self._entries:
             self.PrintIndented(file, '  ', entry.CodeBase())
-        print >>file, '};\n'
+        print('};\n', file=file)
 
         # Creation
-        print >>file, (
+        print((
             'struct %(name)s *\n'
             '%(name)s_new(void)\n'
             '{\n'
@@ -170,77 +169,77 @@ int evtag_unmarshal_%(name)s(struct evbuffer *, ev_uint32_t,
             '    event_warn("%%s: malloc", __func__);\n'
             '    return (NULL);\n'
             '  }\n'
-            '  tmp->base = &__%(name)s_base;\n') % { 'name' : self._name }
+            '  tmp->base = &__%(name)s_base;\n') % { 'name' : self._name }, file=file)
 
         for entry in self._entries:
             self.PrintIndented(file, '  ', entry.CodeInitialize('tmp'))
-            print >>file, '  tmp->%s_set = 0;\n' % entry.Name()
+            print('  tmp->%s_set = 0;\n' % entry.Name(), file=file)
 
-        print >>file, (
+        print((
             '  return (tmp);\n'
-            '}\n')
+            '}\n'), file=file)
 
         # Adding
         for entry in self._entries:
             if entry.Array():
                 self.PrintIndented(file, '', entry.CodeAdd())
-            print >>file, ''
+            print('', file=file)
 
         # Assigning
         for entry in self._entries:
             self.PrintIndented(file, '', entry.CodeAssign())
-            print >>file, ''
+            print('', file=file)
 
         # Getting
         for entry in self._entries:
             self.PrintIndented(file, '', entry.CodeGet())
-            print >>file, ''
+            print('', file=file)
 
         # Clearing
-        print >>file, ( 'void\n'
+        print(( 'void\n'
                         '%(name)s_clear(struct %(name)s *tmp)\n'
                         '{'
-                        ) % { 'name' : self._name }
+                        ) % { 'name' : self._name }, file=file)
         for entry in self._entries:
             self.PrintIndented(file, '  ', entry.CodeClear('tmp'))
 
-        print >>file, '}\n'
+        print('}\n', file=file)
 
         # Freeing
-        print >>file, ( 'void\n'
+        print(( 'void\n'
                         '%(name)s_free(struct %(name)s *tmp)\n'
                         '{'
-                        ) % { 'name' : self._name }
+                        ) % { 'name' : self._name }, file=file)
 
         for entry in self._entries:
             self.PrintIndented(file, '  ', entry.CodeFree('tmp'))
 
-        print >>file, ('  free(tmp);\n'
-                       '}\n')
+        print(('  free(tmp);\n'
+                       '}\n'), file=file)
 
         # Marshaling
-        print >>file, ('void\n'
+        print(('void\n'
                        '%(name)s_marshal(struct evbuffer *evbuf, '
                        'const struct %(name)s *tmp)'
-                       '{') % { 'name' : self._name }
+                       '{') % { 'name' : self._name }, file=file)
         for entry in self._entries:
             indent = '  '
             # Optional entries do not have to be set
             if entry.Optional():
                 indent += '  '
-                print >>file, '  if (tmp->%s_set) {' % entry.Name()
+                print('  if (tmp->%s_set) {' % entry.Name(), file=file)
             self.PrintIndented(
                 file, indent,
                 entry.CodeMarshal('evbuf', self.EntryTagName(entry),
                                   entry.GetVarName('tmp'),
                                   entry.GetVarLen('tmp')))
             if entry.Optional():
-                print >>file, '  }'
+                print('  }', file=file)
 
-        print >>file, '}\n'
+        print('}\n', file=file)
 
         # Unmarshaling
-        print >>file, ('int\n'
+        print(('int\n'
                        '%(name)s_unmarshal(struct %(name)s *tmp, '
                        ' struct evbuffer *evbuf)\n'
                        '{\n'
@@ -249,14 +248,14 @@ int evtag_unmarshal_%(name)s(struct evbuffer *, ev_uint32_t,
                        '    if (evtag_peek(evbuf, &tag) == -1)\n'
                        '      return (-1);\n'
                        '    switch (tag) {\n'
-                       ) % { 'name' : self._name }
+                       ) % { 'name' : self._name }, file=file)
         for entry in self._entries:
-            print >>file, '      case %s:\n' % self.EntryTagName(entry)
+            print('      case %s:\n' % self.EntryTagName(entry), file=file)
             if not entry.Array():
-                print >>file, (
+                print((
                     '        if (tmp->%s_set)\n'
                     '          return (-1);'
-                    ) % (entry.Name())
+                    ) % (entry.Name()), file=file)
 
             self.PrintIndented(
                 file, '        ',
@@ -265,26 +264,26 @@ int evtag_unmarshal_%(name)s(struct evbuffer *, ev_uint32_t,
                                     entry.GetVarName('tmp'),
                                     entry.GetVarLen('tmp')))
 
-            print >>file, ( '        tmp->%s_set = 1;\n' % entry.Name() +
-                            '        break;\n' )
-        print >>file, ( '      default:\n'
+            print(( '        tmp->%s_set = 1;\n' % entry.Name() +
+                            '        break;\n' ), file=file)
+        print(( '      default:\n'
                         '        return -1;\n'
                         '    }\n'
-                        '  }\n' )
+                        '  }\n' ), file=file)
         # Check if it was decoded completely
-        print >>file, ( '  if (%(name)s_complete(tmp) == -1)\n'
+        print(( '  if (%(name)s_complete(tmp) == -1)\n'
                         '    return (-1);'
-                        ) % { 'name' : self._name }
+                        ) % { 'name' : self._name }, file=file)
 
         # Successfully decoded
-        print >>file, ( '  return (0);\n'
-                        '}\n')
+        print(( '  return (0);\n'
+                        '}\n'), file=file)
 
         # Checking if a structure has all the required data
-        print >>file, (
+        print((
             'int\n'
             '%(name)s_complete(struct %(name)s *msg)\n'
-            '{' ) % { 'name' : self._name }
+            '{' ) % { 'name' : self._name }, file=file)
         for entry in self._entries:
             if not entry.Optional():
                 code = [
@@ -297,12 +296,12 @@ int evtag_unmarshal_%(name)s(struct evbuffer *, ev_uint32_t,
             self.PrintIndented(
                 file, '  ',
                 entry.CodeComplete('msg', entry.GetVarName('msg')))
-        print >>file, (
+        print((
             '  return (0);\n'
-            '}\n' )
+            '}\n' ), file=file)
 
         # Complete message unmarshaling
-        print >>file, (
+        print((
             'int\n'
             'evtag_unmarshal_%(name)s(struct evbuffer *evbuf, '
             'ev_uint32_t need_tag, struct %(name)s *msg)\n'
@@ -324,10 +323,10 @@ int evtag_unmarshal_%(name)s(struct evbuffer *, ev_uint32_t,
             ' error:\n'
             '  evbuffer_free(tmp);\n'
             '  return (res);\n'
-            '}\n' ) % { 'name' : self._name }
+            '}\n' ) % { 'name' : self._name }, file=file)
 
         # Complete message marshaling
-        print >>file, (
+        print((
             'void\n'
             'evtag_marshal_%(name)s(struct evbuffer *evbuf, ev_uint32_t tag, '
             'const struct %(name)s *msg)\n'
@@ -337,7 +336,7 @@ int evtag_unmarshal_%(name)s(struct evbuffer *, ev_uint32_t,
             '  %(name)s_marshal(_buf, msg);\n'
             '  evtag_marshal_buffer(evbuf, tag, _buf);\n '
             '  evbuffer_free(_buf);\n'
-            '}\n' ) % { 'name' : self._name }
+            '}\n' ) % { 'name' : self._name }, file=file)
 
 class Entry:
     def __init__(self, type, name, tag):
@@ -1121,7 +1120,7 @@ class EntryArray(Entry):
 
         codearrayassign = self._entry.CodeArrayAssign(
             'msg->%(name)s_data[off]' % self.GetTranslation(), 'value')
-        code += map(lambda x: '    ' + x, codearrayassign)
+        code += ['    ' + x for x in codearrayassign]
 
         code += TranslateList([
             '  }',
@@ -1162,7 +1161,7 @@ class EntryArray(Entry):
 
         code = TranslateList(code, self.GetTranslation())
 
-        code += map(lambda x: '  ' + x, codearrayadd)
+        code += ['  ' + x for x in codearrayadd]
 
         code += TranslateList([
             '  msg->%(name)s_set = 1;',
@@ -1190,7 +1189,7 @@ class EntryArray(Entry):
 
         code = TranslateList(code, translate)
 
-        code += map(lambda x: '    ' + x, tmp)
+        code += ['    ' + x for x in tmp]
 
         code += [
             '  }',
@@ -1255,7 +1254,7 @@ class EntryArray(Entry):
         code = TranslateList(code, translate)
 
         if codearrayfree:
-            code += map(lambda x: '    ' + x, codearrayfree)
+            code += ['    ' + x for x in codearrayfree]
             code += [
                 '  }' ]
 
@@ -1668,31 +1667,31 @@ class CommandLine:
         impl_file = self.impl_file
         factory = self.factory
 
-        print >>sys.stderr, 'Reading \"%s\"' % filename
+        print('Reading \"%s\"' % filename, file=sys.stderr)
 
         fp = open(filename, 'r')
         entities = Parse(factory, fp)
         fp.close()
 
-        print >>sys.stderr, '... creating "%s"' % header_file
+        print('... creating "%s"' % header_file, file=sys.stderr)
         header_fp = open(header_file, 'w')
-        print >>header_fp, factory.HeaderPreamble(filename)
+        print(factory.HeaderPreamble(filename), file=header_fp)
 
         # Create forward declarations: allows other structs to reference
         # each other
         for entry in entities:
             entry.PrintForwardDeclaration(header_fp)
-        print >>header_fp, ''
+        print('', file=header_fp)
 
         for entry in entities:
             entry.PrintTags(header_fp)
             entry.PrintDeclaration(header_fp)
-        print >>header_fp, factory.HeaderPostamble(filename)
+        print(factory.HeaderPostamble(filename), file=header_fp)
         header_fp.close()
 
-        print >>sys.stderr, '... creating "%s"' % impl_file
+        print('... creating "%s"' % impl_file, file=sys.stderr)
         impl_fp = open(impl_file, 'w')
-        print >>impl_fp, factory.BodyPreamble(filename, header_file)
+        print(factory.BodyPreamble(filename, header_file), file=impl_fp)
         for entry in entities:
             entry.PrintCode(impl_fp)
         impl_fp.close()
@@ -1702,16 +1701,16 @@ if __name__ == '__main__':
         CommandLine(sys.argv).run()
         sys.exit(0)
 
-    except RpcGenError, e:
-        print >>sys.stderr, e
+    except RpcGenError as e:
+        print(e, file=sys.stderr)
         sys.exit(1)
 
-    except EnvironmentError, e:
+    except EnvironmentError as e:
         if e.filename and e.strerror:
-            print >>sys.stderr, "%s: %s" % (e.filename, e.strerror)
+            print("%s: %s" % (e.filename, e.strerror), file=sys.stderr)
             sys.exit(1)
         elif e.strerror:
-            print >> sys.stderr, e.strerror
+            print(e.strerror, file=sys.stderr)
             sys.exit(1)
         else:
             raise
diff --git a/ipc/ipdl/ipdl/__init__.py b/ipc/ipdl/ipdl/__init__.py
index d2d883f861..5d169d422a 100644
--- a/ipc/ipdl/ipdl/__init__.py
+++ b/ipc/ipdl/ipdl/__init__.py
@@ -5,7 +5,7 @@
 __all__ = [ 'gencxx', 'genipdl', 'parse', 'typecheck', 'writeifmodified' ]
 
 import os, sys
-from cStringIO import StringIO
+from io import StringIO
 
 from ipdl.cgen import IPDLCodeGen
 from ipdl.lower import LowerToCxx, msgenums
@@ -68,10 +68,10 @@ def writeifmodified(contents, file):
 
     oldcontents = None
     if os.path.exists(file):
-        fd = open(file, 'rb')
+        fd = open(file, 'r')
         oldcontents = fd.read()
         fd.close()
     if oldcontents != contents:
-        fd = open(file, 'wb')
+        fd = open(file, 'w')
         fd.write(contents)
         fd.close()
diff --git a/ipc/ipdl/ipdl/ast.py b/ipc/ipdl/ipdl/ast.py
index a8bd1e41f7..66cbb130e3 100644
--- a/ipc/ipdl/ipdl/ast.py
+++ b/ipc/ipdl/ipdl/ast.py
@@ -13,8 +13,8 @@ HIGH_PRIORITY = 2
 
 class Visitor:
     def defaultVisit(self, node):
-        raise Exception, "INTERNAL ERROR: no visitor for node type `%s'"% (
-            node.__class__.__name__)
+        raise Exception("INTERNAL ERROR: no visitor for node type `%s'"% (
+            node.__class__.__name__))
 
     def visitTranslationUnit(self, tu):
         for cxxInc in tu.cxxIncludes:
@@ -320,7 +320,7 @@ class MessageDecl(Node):
             elif modifier == 'verify':
                 self.verify = modifier
             elif modifier != '':
-                raise Exception, "Unexpected message modifier `%s'"% modifier
+                raise Exception("Unexpected message modifier `%s'"% modifier)
 
 class Transition(Node):
     def __init__(self, loc, trigger, msg, toStates):
diff --git a/ipc/ipdl/ipdl/cxx/ast.py b/ipc/ipdl/ipdl/cxx/ast.py
index 18c2b3f1db..125942f47e 100644
--- a/ipc/ipdl/ipdl/cxx/ast.py
+++ b/ipc/ipdl/ipdl/cxx/ast.py
@@ -3,11 +3,12 @@
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
 import copy, sys
+from functools import reduce
 
 class Visitor:
     def defaultVisit(self, node):
-        raise Exception, "INTERNAL ERROR: no visitor for node type `%s'"% (
-            node.__class__.__name__)
+        raise Exception("INTERNAL ERROR: no visitor for node type `%s'"% (
+            node.__class__.__name__))
 
     def visitWhitespace(self, ws):
         pass
@@ -375,11 +376,11 @@ class Typedef(Node):
         self.totypename = totypename
         self.templateargs = templateargs
 
-    def __cmp__(self, o):
-        return cmp(self.totypename, o.totypename)
+    def __lt__(self, o):
+        return self.totypename < o.totypename
     def __eq__(self, o):
         return (self.__class__ == o.__class__
-                and 0 == cmp(self, o))
+                and self.totypename == o.totypename)
     def __hash__(self):
         return hash(self.totypename)
 
diff --git a/ipc/ipdl/ipdl/lower.py b/ipc/ipdl/ipdl/lower.py
index 61855a7a9e..4b373fda7d 100644
--- a/ipc/ipdl/ipdl/lower.py
+++ b/ipc/ipdl/ipdl/lower.py
@@ -1730,7 +1730,7 @@ class _GenerateProtocolCode(ipdl.ast.Visitor):
                 transitions.append(ifsametrigger)
                 msgToTransitions[msgid] = transitions
 
-            for msgid, transitions in msgToTransitions.iteritems():
+            for msgid, transitions in msgToTransitions.items():
                 block = Block()
                 block.addstmts(transitions +[ StmtBreak() ])
                 msgswitch.addcase(CaseLabel(msgid), block)
diff --git a/ipc/ipdl/ipdl/parser.py b/ipc/ipdl/ipdl/parser.py
index 38c46dc73a..6cb99163a5 100644
--- a/ipc/ipdl/ipdl/parser.py
+++ b/ipc/ipdl/ipdl/parser.py
@@ -2,6 +2,7 @@
 # License, v. 2.0. If a copy of the MPL was not distributed with this
 # file, You can obtain one at http://mozilla.org/MPL/2.0/.
 
+from __future__ import print_function
 import os, sys
 from ply import lex, yacc
 
@@ -78,8 +79,8 @@ class Parser:
         try:
             ast = self.parser.parse(input=input, lexer=self.lexer,
                                     debug=self.debug)
-        except ParseError, p:
-            print >>errout, p
+        except ParseError as p:
+            print(p, file=errout)
             return None
 
         Parser.current = Parser.parseStack.pop()
@@ -648,7 +649,7 @@ def p_Nested(p):
     if p[1] not in kinds:
         _error(locFromTok(p, 1), "Expected not, inside_sync, or inside_cpow for nested()")
 
-    p[0] = { 'nested': kinds[p[1]] }
+    p[0] = kinds[p[1]]
 
 def p_Priority(p):
     """Priority : ID"""
@@ -662,7 +663,10 @@ def p_Priority(p):
 def p_SendQualifier(p):
     """SendQualifier : NESTED '(' Nested ')'
                      | PRIO '(' Priority ')'"""
-    p[0] = p[3]
+    if p[1] == 'nested':
+        p[0] = {'nested': p[3]}
+    else:
+        p[0] = p[3]
 
 def p_SendQualifierList(p):
     """SendQualifierList : SendQualifier SendQualifierList
